mode(-1);
// specific part
libname='xpmlib'

// generic part  
// get the absolute path 
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1 
  l=strindex(nams(k),'builder.sce');
  if l<>[] then
    DIR=part(nams(k),1:l($)-1);
    break
  end
end

tab=code2str(-40)
if ~MSDOS then // Unix Linux
  if part(DIR,1)<>'/' then DIR=getcwd()+'/'+DIR,end
  MACROS=DIR+'macros/'
  SRC=DIR+'src/'
  // Create Makefile
  u=file('open',SRC+'Makefile','unknown')
  write(u,['SCIDIR = '+SCI
      'LIBRARY = array2xpm.a '
      'OBJSC = carr2xpm.o'
      'include '+SCI+'/Makefile.incl'
      'CFLAGS = $(CC_OPTIONS)  $(CC_PICFLAGS) -I'+SCI+'/routines'
      'FFLAGS = $(FC_OPTIONS)  $(FC_PICFLAGS) -I'+SCI+'/routines'
      'include '+SCI+'/routines/Make.lib'
      'all :: arr2xpm.o'],'(a)')
  file('close',u)
  cmd_make='make'
else // windows Visual C++
  if part(DIR,2)<>':' then DIR=getcwd()+'\'+DIR,end
  SRC=DIR+'src\'
  MACROS=DIR+'macros\'
  SCI=strsubst(SCI,'/','\')
  
  //to avoid problems with pathnames including long names we make 
  // a local copy of  $SCI/Makefile.incl.mak
  mkf=read(SCI+'\Makefile.incl.mak',-1,1,'(a)')
  mkf=strsubst(mkf,'$(SCIDIR)/routines/f2c','""'+SCI+'\routines\f2c""')
  mkf=strsubst(mkf,'$(SCIDIR1)\bin\f2c.exe','""'+SCI+'\bin\f2c.exe""')
  mkf=strsubst(mkf,'$(SCIDIR)',SCI)
  mkf=strsubst(mkf,'$(SCIDIR1)',SCI)

  u=file('open',DIR+'Makefile.incl.mak','unknown')
  write(u,mkf,'(a)')
  file('close',u)
  
  u=file('open',SRC+'Makefile','unknown')
  //create the makefile
  write(u,['SCIDIR1 = ""'+SCI+'""'
      'SCIDIR = ""'+SCI+'""'
      'DUMPEXTS = ""'+SCI+'\bin\dumpexts.exe""'
      'SCIIMPLIB = ""'+SCI+'\bin\LibScilab.lib""'
      'LIBRARY = array2xpm.lib '
      'OBJSF = arr2xpm.obj'
      'OBJSC = carr2xpm.obj'
      'include ..\Makefile.incl.mak'
      'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+SCI+'\routines""'
      'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI+'\routines""'
      ' '
      'all :: arr2xpm.dll'
      ' '
      'arr2xpm.dll: $(OBJSC) $(OBJSF)'
        tab+'@$(DUMPEXTS) -o ""$*.def"" ""$*.dll"" $**'
        tab+'@$(LINKER) $(LINKER_FLAGS) $(OBJSF)  $(OBJSC)  $(SCIIMPLIB) $(XLIBSBIN)'+..
      ' $(TERMCAPLIB) /nologo /dll /out:""$*.dll"" /implib:""$*.ilib"" '+..
      '/def:""$*.def""'],'(a)')
  file('close',u)
  cmd_make='nmake /f Makefile'
end
// compile Fortran et C sources in src
OLD=getcwd();chdir(SRC)
unix_s(cmd_make)
chdir(OLD);

//compile sci files if necessary and build lib file
genlib(libname,MACROS)

clear fd err nams DIR libname MACROS genlib SRC OLD cmd_make u

